<?php

namespace Litematrimony\Preference;

use User;

class Preference
{
    /**
     * $preference object.
     */
    protected $preference;

    /**
     * Constructor.
     */
    public function __construct(\Litematrimony\Preference\Interfaces\PreferenceRepositoryInterface $preference)
    {
        $this->preference = $preference;
    }

    /**
     * Returns count of preference.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.preference.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->preference->pushCriteria(new \Litepie\Litematrimony\Repositories\Criteria\PreferenceUserCriteria());
        }

        $preference = $this->preference->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('preference::' . $view, compact('preference'))->render();
    }
}
